#!/sbin/sh

# Sccsid @(#)maninst.sh	1.5 (gritter) 10/11/03

usage() {
	echo "usage: $1 [-c] [-g group] [-m mode] [-o owner] file destination" >&2
	exit 2
}

owner= mode= group=

while getopts cg:m:o: arg
do
	case $arg in
	c)	;;
	g)	group=$OPTARG ;;
	o)	owner=$OPTARG ;;
	m)	mode=$OPTARG ;;
	*)	usage $0 ;;
	esac
done

test $OPTIND -gt 1 && shift `expr $OPTIND - 1`
test $# != 3 || usage $0

<"$1" >"$2" sed '
	s,/usr/5lib,@DEFLIB@,g
	s,@.DEFBIN.@,@DEFBIN@,g
	s,/usr/5bin,@SV3BIN@,g
	s,/usr/5bin/s42,@S42BIN@,g
	s,/usr/5bin/posix,@SUSBIN@,g
	s,/usr/ucb,@UCBBIN@,g
	s,/var/adm/spellhist,@SPELLHIST@,g
	s,/etc/default,@DFLDIR@,g
	s,/usr/5lib/magic,@MAGIC@,g
'

test "x$owner" != x && chown "$owner" "$2"
test "x$group" != x && chgrp "$group" "$2"
test "x$mode" != x && chmod "$mode" "$2"
