/*
 * Copyright (c) 2003 Gunnar Ritter
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute
 * it freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 *
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 */
/*	Sccsid @(#)ftw.h	1.2 (gritter) 4/17/03	*/

struct FTW {
	int	base;
	int	level;
};

/************
 * File types
 ************/
/*
 * File (regular, character, block, FIFO, etc.)
 */
#define	FTW_F		01

/*
 * Directory with FTW_DEPTH unset.
 */
#define	FTW_D		02

/*
 * Unreadable directory.
 */
#define	FTW_DNR		03

/*
 * Directory with FTW_DEPTH set.
 */
#define	FTW_DP		04

/*
 * stat() failed with EACCES.
 */
#define	FTW_NS		05

/*
 * Broken symbolic link with FTW_PHYS unset.
 */
#define	FTW_SL		06

/*
 * Symbolic link with FTW_PHYS set.
 */
#define	FTW_SLN		07

/*******************
 * Flags for nftw().
 *******************/
/*
 * Do not follow symbolic links.
 */
#define	FTW_PHYS	01

/*
 * Do not cross device boundaries.
 */
#define	FTW_MOUNT	02

/*
 * Invoke fn() for a directory after processing its contents.
 */
#define	FTW_DEPTH	04

/*
 * Change into each directory while examining it. This is faster, as
 * it reduced pathname lookup, and works for arbitrary directory
 * depths.
 */
#define	FTW_CHDIR	010

extern int	nftw(const char *, int (*)(const char *, const struct stat *,
			int, struct FTW *), int, int);
