/*
 * Copyright (c) 2004 Gunnar Ritter
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute
 * it freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 *
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 */
/*	Sccsid @(#)_utmpx.h	1.3 (gritter) 5/1/04	*/

#if defined (__FreeBSD__) || defined (__dietlibc__)
#include <sys/types.h>
#include <sys/time.h>
#include <utmp.h>

#ifndef	__dietlibc__
struct utmpx {
	char	ut_user[UT_NAMESIZE];
	char	ut_id[UT_LINESIZE];
	char	ut_line[UT_LINESIZE];
	char	ut_host[UT_HOSTSIZE];
	pid_t	ut_pid;
	short	ut_type;
	struct timeval	ut_tv;
	struct {
		int	e_termination;
		int	e_exit;
	} ut_exit;
};

#define	EMPTY		0
#define	BOOT_TIME	1
#define	OLD_TIME	2
#define	NEW_TIME	3
#define	USER_PROCESS	4
#define	INIT_PROCESS	5
#define	LOGIN_PROCESS	6
#define	DEAD_PROCESS	7
#define	RUN_LVL		8
#define	ACCOUNTING	9
#else	/* __dietlibc__ */
#define	utmpx	utmp
#endif	/* __dietlibc__ */

extern void		endutxent(void);
extern struct utmpx	*getutxent(void);
extern struct utmpx	*getutxid(const struct utmpx *);
extern struct utmpx	*getutxline(const struct utmpx *);
extern struct utmpx	*pututxline(const struct utmpx *);
extern void		setutxent(void);
extern int		utmpxname(const char *);
extern void		updwtmpx(const char *, const struct utmpx *);
#endif	/* __FreeBSD__ || __dietlibc__ */
